/*
{__                              {___     {__{________  {__ __  
{__                              {_ {__   {__{__      {__    {__
{__  {__   {__    {__   {__      {__ {__  {__{__       {__      
{__ {__  {_   {__  {__ {__       {__  {__ {__{______     {__    
{_{__   {_____ {__   {___        {__   {_ {__{__            {__ 
{__ {__ {_            {__        {__    {_ __{__      {__    {__
{__  {__  {____      {__         {__      {__{________  {__ __  
                   {__     {_____                               

                 ________________________________
                            "key_NES"
                  Arduino sketch for key_NES app
                   by Joey Kelly | tapesong.com
                 version 1.1 | 1st December 2010
                 ________________________________

 PAD Socket Pinout  |        Arduino Pinouts
                    |
     _____          |              PAD1       PAD2 
    /   0| - GND    |   GND        gnd         5
5V- |0  0| - CLOCK  |   5V         5v          6
    |0  0| - LATCH  |   CLOCK      2           7
    |0  0| - DATA   |   LATCH      3           8 
    ------          |   DATA       4           9
    
    
 This sketch is an adaptation of:
 
             *******
    "Reading a NES Controller"
    By Sebastian Tomczak
    21 July 2007
    Adelaide, Australia
             *******
       
            found at 
http://little-scale.blogspot.com


*/

/* INITIALISATION */


int clock = 2; // set the clock pin
int latch = 3; // set the latch pin
int datin = 4;// set the data in pin
int clock2 = 7; //set the clock pin PAD2
int latch2 = 8; //set the latch pin PAD2
int datin2 = 9; //set the data in pin PAD2


int powneg = 5; // set power pins for PAD2
int powpos = 6;

byte controller_data = 0;  // PAD1
byte controller_data2 = 0; // PAD2


/* SETUP */
void setup() {
Serial.begin(57600);
pinMode(latch,OUTPUT);
pinMode(clock,OUTPUT);
pinMode(datin,INPUT);
pinMode(latch2,OUTPUT);
pinMode(clock2,OUTPUT);
pinMode(datin2,INPUT);
pinMode(powneg,OUTPUT);
pinMode(powpos,OUTPUT);

digitalWrite(latch,HIGH);
digitalWrite(clock,HIGH);
digitalWrite(latch2,HIGH);
digitalWrite(clock2,HIGH);
digitalWrite(powneg,LOW); 
digitalWrite(powpos,HIGH);
}

/* CONTROLLER READ */
void controllerRead() {
controller_data = 0;
digitalWrite(latch,LOW);
digitalWrite(clock,LOW);

digitalWrite(latch,HIGH);
delayMicroseconds(2);
digitalWrite(latch,LOW);

controller_data = digitalRead(datin);

for (int i = 1; i <= 7; i ++) {
digitalWrite(clock,HIGH);
delayMicroseconds(2);
controller_data = controller_data << 1;
controller_data = controller_data + digitalRead(datin) ;
delayMicroseconds(4);
digitalWrite(clock,LOW);
}

}

/* CONTROLLER READ - PAD2 */ 
void controllerRead2() {
controller_data2 = 0;
digitalWrite(latch2,LOW);
digitalWrite(clock2,LOW);

digitalWrite(latch2,HIGH);
delayMicroseconds(2);
digitalWrite(latch2,LOW);

controller_data2 = digitalRead(datin2);

for (int i = 1; i <= 7; i ++) {
digitalWrite(clock2,HIGH);
delayMicroseconds(2);
controller_data2 = controller_data2 << 1;
controller_data2 = controller_data2 + digitalRead(datin2) ;
delayMicroseconds(4);
digitalWrite(clock2,LOW);
}

}

/* PROGRAM */
void loop() {
controllerRead();
controllerRead2();

Serial.print(1, BYTE);
Serial.print(controller_data, BYTE);
Serial.print(controller_data2, BYTE);



delay(10);
} 
